Index: uspace/app/test_serial/test_serial.c
===================================================================
--- uspace/app/test_serial/test_serial.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/app/test_serial/test_serial.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -69,5 +69,5 @@
 	int res;
 	res = devman_get_phone(DEVMAN_CLIENT, IPC_FLAG_BLOCKING);
-	device_handle_t handle;
+	devman_handle_t handle;
 	
 	res = devman_device_get_handle("/hw/pci0/00:01.0/com1", &handle,
Index: uspace/lib/block/libblock.c
===================================================================
--- uspace/lib/block/libblock.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/block/libblock.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -75,5 +75,5 @@
 typedef struct {
 	link_t link;
-	dev_handle_t dev_handle;
+	devmap_handle_t devmap_handle;
 	int dev_phone;
 	fibril_mutex_t comm_area_lock;
@@ -91,5 +91,5 @@
 static int get_num_blocks(int dev_phone, aoff64_t *nblocks);
 
-static devcon_t *devcon_search(dev_handle_t dev_handle)
+static devcon_t *devcon_search(devmap_handle_t devmap_handle)
 {
 	link_t *cur;
@@ -98,5 +98,5 @@
 	for (cur = dcl_head.next; cur != &dcl_head; cur = cur->next) {
 		devcon_t *devcon = list_get_instance(cur, devcon_t, link);
-		if (devcon->dev_handle == dev_handle) {
+		if (devcon->devmap_handle == devmap_handle) {
 			fibril_mutex_unlock(&dcl_lock);
 			return devcon;
@@ -107,5 +107,5 @@
 }
 
-static int devcon_add(dev_handle_t dev_handle, int dev_phone, size_t bsize,
+static int devcon_add(devmap_handle_t devmap_handle, int dev_phone, size_t bsize,
     void *comm_area, size_t comm_size)
 {
@@ -121,5 +121,5 @@
 	
 	link_initialize(&devcon->link);
-	devcon->dev_handle = dev_handle;
+	devcon->devmap_handle = devmap_handle;
 	devcon->dev_phone = dev_phone;
 	fibril_mutex_initialize(&devcon->comm_area_lock);
@@ -134,5 +134,5 @@
 	for (cur = dcl_head.next; cur != &dcl_head; cur = cur->next) {
 		devcon_t *d = list_get_instance(cur, devcon_t, link);
-		if (d->dev_handle == dev_handle) {
+		if (d->devmap_handle == devmap_handle) {
 			fibril_mutex_unlock(&dcl_lock);
 			free(devcon);
@@ -152,5 +152,5 @@
 }
 
-int block_init(dev_handle_t dev_handle, size_t comm_size)
+int block_init(devmap_handle_t devmap_handle, size_t comm_size)
 {
 	int rc;
@@ -165,5 +165,5 @@
 	}
 
-	dev_phone = devmap_device_connect(dev_handle, IPC_FLAG_BLOCKING);
+	dev_phone = devmap_device_connect(devmap_handle, IPC_FLAG_BLOCKING);
 	if (dev_phone < 0) {
 		munmap(comm_area, comm_size);
@@ -185,5 +185,5 @@
 	}
 	
-	rc = devcon_add(dev_handle, dev_phone, bsize, comm_area, comm_size);
+	rc = devcon_add(devmap_handle, dev_phone, bsize, comm_area, comm_size);
 	if (rc != EOK) {
 		munmap(comm_area, comm_size);
@@ -195,11 +195,11 @@
 }
 
-void block_fini(dev_handle_t dev_handle)
-{
-	devcon_t *devcon = devcon_search(dev_handle);
+void block_fini(devmap_handle_t devmap_handle)
+{
+	devcon_t *devcon = devcon_search(devmap_handle);
 	assert(devcon);
 	
 	if (devcon->cache)
-		(void) block_cache_fini(dev_handle);
+		(void) block_cache_fini(devmap_handle);
 
 	devcon_remove(devcon);
@@ -214,10 +214,10 @@
 }
 
-int block_bb_read(dev_handle_t dev_handle, aoff64_t ba)
+int block_bb_read(devmap_handle_t devmap_handle, aoff64_t ba)
 {
 	void *bb_buf;
 	int rc;
 
-	devcon_t *devcon = devcon_search(dev_handle);
+	devcon_t *devcon = devcon_search(devmap_handle);
 	if (!devcon)
 		return ENOENT;
@@ -244,7 +244,7 @@
 }
 
-void *block_bb_get(dev_handle_t dev_handle)
-{
-	devcon_t *devcon = devcon_search(dev_handle);
+void *block_bb_get(devmap_handle_t devmap_handle)
+{
+	devcon_t *devcon = devcon_search(devmap_handle);
 	assert(devcon);
 	return devcon->bb_buf;
@@ -272,8 +272,8 @@
 };
 
-int block_cache_init(dev_handle_t dev_handle, size_t size, unsigned blocks,
+int block_cache_init(devmap_handle_t devmap_handle, size_t size, unsigned blocks,
     enum cache_mode mode)
 {
-	devcon_t *devcon = devcon_search(dev_handle);
+	devcon_t *devcon = devcon_search(devmap_handle);
 	cache_t *cache;
 	if (!devcon)
@@ -305,7 +305,7 @@
 }
 
-int block_cache_fini(dev_handle_t dev_handle)
-{
-	devcon_t *devcon = devcon_search(dev_handle);
+int block_cache_fini(devmap_handle_t devmap_handle)
+{
+	devcon_t *devcon = devcon_search(devmap_handle);
 	cache_t *cache;
 	int rc;
@@ -374,5 +374,5 @@
  * @param block			Pointer to where the function will store the
  * 				block pointer on success.
- * @param dev_handle		Device handle of the block device.
+ * @param devmap_handle		Device handle of the block device.
  * @param boff			Block offset.
  * @param flags			If BLOCK_FLAGS_NOREAD is specified, block_get()
@@ -382,5 +382,5 @@
  * @return			EOK on success or a negative error code.
  */
-int block_get(block_t **block, dev_handle_t dev_handle, aoff64_t boff, int flags)
+int block_get(block_t **block, devmap_handle_t devmap_handle, aoff64_t boff, int flags)
 {
 	devcon_t *devcon;
@@ -391,5 +391,5 @@
 	int rc;
 	
-	devcon = devcon_search(dev_handle);
+	devcon = devcon_search(devmap_handle);
 
 	assert(devcon);
@@ -500,5 +500,5 @@
 
 		block_initialize(b);
-		b->dev_handle = dev_handle;
+		b->devmap_handle = devmap_handle;
 		b->size = cache->lblock_size;
 		b->boff = boff;
@@ -549,5 +549,5 @@
 int block_put(block_t *block)
 {
-	devcon_t *devcon = devcon_search(block->dev_handle);
+	devcon_t *devcon = devcon_search(block->devmap_handle);
 	cache_t *cache;
 	unsigned blocks_cached;
@@ -645,5 +645,5 @@
 /** Read sequential data from a block device.
  *
- * @param dev_handle	Device handle of the block device.
+ * @param devmap_handle	Device handle of the block device.
  * @param bufpos	Pointer to the first unread valid offset within the
  * 			communication buffer.
@@ -657,5 +657,5 @@
  * @return		EOK on success or a negative return code on failure.
  */
-int block_seqread(dev_handle_t dev_handle, size_t *bufpos, size_t *buflen,
+int block_seqread(devmap_handle_t devmap_handle, size_t *bufpos, size_t *buflen,
     aoff64_t *pos, void *dst, size_t size)
 {
@@ -665,5 +665,5 @@
 	devcon_t *devcon;
 
-	devcon = devcon_search(dev_handle);
+	devcon = devcon_search(devmap_handle);
 	assert(devcon);
 	block_size = devcon->pblock_size;
@@ -711,5 +711,5 @@
 /** Read blocks directly from device (bypass cache).
  *
- * @param dev_handle	Device handle of the block device.
+ * @param devmap_handle	Device handle of the block device.
  * @param ba		Address of first block.
  * @param cnt		Number of blocks.
@@ -718,10 +718,10 @@
  * @return		EOK on success or negative error code on failure.
  */
-int block_read_direct(dev_handle_t dev_handle, aoff64_t ba, size_t cnt, void *buf)
+int block_read_direct(devmap_handle_t devmap_handle, aoff64_t ba, size_t cnt, void *buf)
 {
 	devcon_t *devcon;
 	int rc;
 
-	devcon = devcon_search(dev_handle);
+	devcon = devcon_search(devmap_handle);
 	assert(devcon);
 	
@@ -739,5 +739,5 @@
 /** Write blocks directly to device (bypass cache).
  *
- * @param dev_handle	Device handle of the block device.
+ * @param devmap_handle	Device handle of the block device.
  * @param ba		Address of first block.
  * @param cnt		Number of blocks.
@@ -746,5 +746,5 @@
  * @return		EOK on success or negative error code on failure.
  */
-int block_write_direct(dev_handle_t dev_handle, aoff64_t ba, size_t cnt,
+int block_write_direct(devmap_handle_t devmap_handle, aoff64_t ba, size_t cnt,
     const void *data)
 {
@@ -752,5 +752,5 @@
 	int rc;
 
-	devcon = devcon_search(dev_handle);
+	devcon = devcon_search(devmap_handle);
 	assert(devcon);
 	
@@ -767,14 +767,14 @@
 /** Get device block size.
  *
- * @param dev_handle	Device handle of the block device.
+ * @param devmap_handle	Device handle of the block device.
  * @param bsize		Output block size.
  *
  * @return		EOK on success or negative error code on failure.
  */
-int block_get_bsize(dev_handle_t dev_handle, size_t *bsize)
+int block_get_bsize(devmap_handle_t devmap_handle, size_t *bsize)
 {
 	devcon_t *devcon;
 
-	devcon = devcon_search(dev_handle);
+	devcon = devcon_search(devmap_handle);
 	assert(devcon);
 	
@@ -784,14 +784,14 @@
 /** Get number of blocks on device.
  *
- * @param dev_handle	Device handle of the block device.
+ * @param devmap_handle	Device handle of the block device.
  * @param nblocks	Output number of blocks.
  *
  * @return		EOK on success or negative error code on failure.
  */
-int block_get_nblocks(dev_handle_t dev_handle, aoff64_t *nblocks)
+int block_get_nblocks(devmap_handle_t devmap_handle, aoff64_t *nblocks)
 {
 	devcon_t *devcon;
 
-	devcon = devcon_search(dev_handle);
+	devcon = devcon_search(devmap_handle);
 	assert(devcon);
 	
@@ -818,5 +818,5 @@
 		printf("Error %d reading %d blocks starting at block %" PRIuOFF64
 		    " from device handle %d\n", rc, cnt, ba,
-		    devcon->dev_handle);
+		    devcon->devmap_handle);
 #ifndef NDEBUG
 		stacktrace_print();
@@ -844,5 +844,5 @@
 	if (rc != EOK) {
 		printf("Error %d writing %d blocks starting at block %" PRIuOFF64
-		    " to device handle %d\n", rc, cnt, ba, devcon->dev_handle);
+		    " to device handle %d\n", rc, cnt, ba, devcon->devmap_handle);
 #ifndef NDEBUG
 		stacktrace_print();
Index: uspace/lib/block/libblock.h
===================================================================
--- uspace/lib/block/libblock.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/block/libblock.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -72,5 +72,5 @@
 	fibril_rwlock_t contents_lock;
 	/** Handle of the device where the block resides. */
-	dev_handle_t dev_handle;
+	devmap_handle_t devmap_handle;
 	/** Block offset on the block device. Counted in 'size'-byte blocks. */
 	aoff64_t boff;
@@ -93,23 +93,23 @@
 };
 
-extern int block_init(dev_handle_t, size_t);
-extern void block_fini(dev_handle_t);
+extern int block_init(devmap_handle_t, size_t);
+extern void block_fini(devmap_handle_t);
 
-extern int block_bb_read(dev_handle_t, aoff64_t);
-extern void *block_bb_get(dev_handle_t);
+extern int block_bb_read(devmap_handle_t, aoff64_t);
+extern void *block_bb_get(devmap_handle_t);
 
-extern int block_cache_init(dev_handle_t, size_t, unsigned, enum cache_mode);
-extern int block_cache_fini(dev_handle_t);
+extern int block_cache_init(devmap_handle_t, size_t, unsigned, enum cache_mode);
+extern int block_cache_fini(devmap_handle_t);
 
-extern int block_get(block_t **, dev_handle_t, aoff64_t, int);
+extern int block_get(block_t **, devmap_handle_t, aoff64_t, int);
 extern int block_put(block_t *);
 
-extern int block_seqread(dev_handle_t, size_t *, size_t *, aoff64_t *, void *,
+extern int block_seqread(devmap_handle_t, size_t *, size_t *, aoff64_t *, void *,
     size_t);
 
-extern int block_get_bsize(dev_handle_t, size_t *);
-extern int block_get_nblocks(dev_handle_t, aoff64_t *);
-extern int block_read_direct(dev_handle_t, aoff64_t, size_t, void *);
-extern int block_write_direct(dev_handle_t, aoff64_t, size_t, const void *);
+extern int block_get_bsize(devmap_handle_t, size_t *);
+extern int block_get_nblocks(devmap_handle_t, aoff64_t *);
+extern int block_read_direct(devmap_handle_t, aoff64_t, size_t, void *);
+extern int block_write_direct(devmap_handle_t, aoff64_t, size_t, const void *);
 
 #endif
Index: uspace/lib/c/generic/adt/measured_strings.c
===================================================================
--- uspace/lib/c/generic/adt/measured_strings.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/generic/adt/measured_strings.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -41,5 +41,4 @@
 #include <unistd.h>
 #include <errno.h>
-#include <err.h>
 #include <async.h>
 
@@ -135,6 +134,4 @@
     size_t count)
 {
-	ERROR_DECLARE;
-
 	size_t *lengths;
 	size_t index;
@@ -142,4 +139,5 @@
 	char *next;
 	ipc_callid_t callid;
+	int rc;
 
 	if ((!strings) || (!data) || (count <= 0))
@@ -155,8 +153,8 @@
 		return EINVAL;
 	}
-	if (ERROR_OCCURRED(async_data_write_finalize(callid, lengths,
-	    length))) {
-		free(lengths);
-		return ERROR_CODE;
+	rc = async_data_write_finalize(callid, lengths, length);
+	if (rc != EOK) {
+		free(lengths);
+		return rc;
 	}
 
@@ -187,10 +185,11 @@
 				return EINVAL;
 			}
-			if (ERROR_OCCURRED(async_data_write_finalize(callid,
-			    next, lengths[index]))) {
+			rc = async_data_write_finalize(callid, next,
+			    lengths[index]);
+			if (rc != EOK) {
 				free(*data);
 				free(*strings);
 				free(lengths);
-				return ERROR_CODE;
+				return rc;
 			}
 			(*strings)[index].value = next;
@@ -251,10 +250,9 @@
 int measured_strings_reply(const measured_string_ref strings, size_t count)
 {
-	ERROR_DECLARE;
-
 	size_t *lengths;
 	size_t index;
 	size_t length;
 	ipc_callid_t callid;
+	int rc;
 
 	if ((!strings) || (count <= 0))
@@ -270,7 +268,8 @@
 		return EINVAL;
 	}
-	if (ERROR_OCCURRED(async_data_read_finalize(callid, lengths, length))) {
-		free(lengths);
-		return ERROR_CODE;
+	rc = async_data_read_finalize(callid, lengths, length);
+	if (rc != EOK) {
+		free(lengths);
+		return rc;
 	}
 	free(lengths);
@@ -282,6 +281,8 @@
 				return EINVAL;
 			}
-			ERROR_PROPAGATE(async_data_read_finalize(callid,
-			    strings[index].value, strings[index].length));
+			rc = async_data_read_finalize(callid,
+			    strings[index].value, strings[index].length);
+			if (rc != EOK)
+				return rc;
 		}
 	}
@@ -313,9 +314,8 @@
     size_t count)
 {
-	ERROR_DECLARE;
-
 	size_t *lengths;
 	size_t index;
 	char *next;
+	int rc;
 
 	if ((phone < 0) || (!strings) || (!data) || (count <= 0))
@@ -326,8 +326,9 @@
 		return ENOMEM;
 
-	if (ERROR_OCCURRED(async_data_read_start(phone, lengths,
-	    sizeof(size_t) * (count + 1)))) {
-		free(lengths);
-		return ERROR_CODE;
+	rc = async_data_read_start(phone, lengths,
+	    sizeof(size_t) * (count + 1));
+	if (rc != EOK) {
+		free(lengths);
+		return rc;
 	}
 
@@ -350,10 +351,10 @@
 		(*strings)[index].length = lengths[index];
 		if (lengths[index] > 0) {
-			if (ERROR_OCCURRED(async_data_read_start(phone, next,
-			    lengths[index]))) {
+			rc = async_data_read_start(phone, next, lengths[index]);
+			if (rc != EOK) {
 			    	free(lengths);
 				free(data);
 				free(strings);
-				return ERROR_CODE;
+				return rc;
 			}
 			(*strings)[index].value = next;
@@ -387,8 +388,7 @@
     size_t count)
 {
-	ERROR_DECLARE;
-
 	size_t *lengths;
 	size_t index;
+	int rc;
 
 	if ((phone < 0) || (!strings) || (count <= 0))
@@ -399,8 +399,9 @@
 		return ENOMEM;
 
-	if (ERROR_OCCURRED(async_data_write_start(phone, lengths,
-	    sizeof(size_t) * (count + 1)))) {
-		free(lengths);
-		return ERROR_CODE;
+	rc = async_data_write_start(phone, lengths,
+	    sizeof(size_t) * (count + 1));
+	if (rc != EOK) {
+		free(lengths);
+		return rc;
 	}
 
@@ -409,6 +410,8 @@
 	for (index = 0; index < count; index++) {
 		if (strings[index].length > 0) {
-			ERROR_PROPAGATE(async_data_write_start(phone,
-			    strings[index].value, strings[index].length));
+			rc = async_data_write_start(phone, strings[index].value,
+			    strings[index].length);
+			if (rc != EOK)
+				return rc;
 		}
 	}
Index: uspace/lib/c/generic/devman.c
===================================================================
--- uspace/lib/c/generic/devman.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/generic/devman.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -141,5 +141,5 @@
 
 int devman_child_device_register(
-	const char *name, match_id_list_t *match_ids, device_handle_t parent_handle, device_handle_t *handle)
+	const char *name, match_id_list_t *match_ids, devman_handle_t parent_handle, devman_handle_t *handle)
 {		
 	int phone = devman_get_phone(DEVMAN_DRIVER, IPC_FLAG_BLOCKING);
@@ -180,5 +180,5 @@
 }
 
-int devman_add_device_to_class(device_handle_t dev_handle, const char *class_name)
+int devman_add_device_to_class(devman_handle_t devman_handle, const char *class_name)
 {
 	int phone = devman_get_phone(DEVMAN_DRIVER, IPC_FLAG_BLOCKING);
@@ -189,5 +189,5 @@
 	async_serialize_start();
 	ipc_call_t answer;
-	aid_t req = async_send_1(phone, DEVMAN_ADD_DEVICE_TO_CLASS, dev_handle, &answer);
+	aid_t req = async_send_1(phone, DEVMAN_ADD_DEVICE_TO_CLASS, devman_handle, &answer);
 	
 	ipcarg_t retval = async_data_write_start(phone, class_name, str_size(class_name));
@@ -224,5 +224,5 @@
 }
 
-int devman_device_connect(device_handle_t handle, unsigned int flags)
+int devman_device_connect(devman_handle_t handle, unsigned int flags)
 {
 	int phone;
@@ -239,5 +239,5 @@
 }
 
-int devman_parent_device_connect(device_handle_t handle, unsigned int flags)
+int devman_parent_device_connect(devman_handle_t handle, unsigned int flags)
 {
 	int phone;
@@ -254,5 +254,5 @@
 }
 
-int devman_device_get_handle(const char *pathname, device_handle_t *handle, unsigned int flags)
+int devman_device_get_handle(const char *pathname, devman_handle_t *handle, unsigned int flags)
 {
 	int phone = devman_get_phone(DEVMAN_CLIENT, flags);
@@ -280,10 +280,10 @@
 	if (retval != EOK) {
 		if (handle != NULL)
-			*handle = (device_handle_t) -1;
+			*handle = (devman_handle_t) -1;
 		return retval;
 	}
 	
 	if (handle != NULL)
-		*handle = (device_handle_t) IPC_GET_ARG1(answer);
+		*handle = (devman_handle_t) IPC_GET_ARG1(answer);
 	
 	return retval;
Index: uspace/lib/c/generic/devmap.c
===================================================================
--- uspace/lib/c/generic/devmap.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/generic/devmap.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -132,5 +132,5 @@
  *
  */
-int devmap_device_register(const char *fqdn, dev_handle_t *handle)
+int devmap_device_register(const char *fqdn, devmap_handle_t *handle)
 {
 	int phone = devmap_get_phone(DEVMAP_DRIVER, IPC_FLAG_BLOCKING);
@@ -163,10 +163,10 @@
 	
 	if (handle != NULL)
-		*handle = (dev_handle_t) IPC_GET_ARG1(answer);
+		*handle = (devmap_handle_t) IPC_GET_ARG1(answer);
 	
 	return retval;
 }
 
-int devmap_device_get_handle(const char *fqdn, dev_handle_t *handle, unsigned int flags)
+int devmap_device_get_handle(const char *fqdn, devmap_handle_t *handle, unsigned int flags)
 {
 	int phone = devmap_get_phone(DEVMAP_CLIENT, flags);
@@ -194,15 +194,15 @@
 	if (retval != EOK) {
 		if (handle != NULL)
-			*handle = (dev_handle_t) -1;
+			*handle = (devmap_handle_t) -1;
 		return retval;
 	}
 	
 	if (handle != NULL)
-		*handle = (dev_handle_t) IPC_GET_ARG1(answer);
+		*handle = (devmap_handle_t) IPC_GET_ARG1(answer);
 	
 	return retval;
 }
 
-int devmap_namespace_get_handle(const char *name, dev_handle_t *handle, unsigned int flags)
+int devmap_namespace_get_handle(const char *name, devmap_handle_t *handle, unsigned int flags)
 {
 	int phone = devmap_get_phone(DEVMAP_CLIENT, flags);
@@ -230,15 +230,15 @@
 	if (retval != EOK) {
 		if (handle != NULL)
-			*handle = (dev_handle_t) -1;
+			*handle = (devmap_handle_t) -1;
 		return retval;
 	}
 	
 	if (handle != NULL)
-		*handle = (dev_handle_t) IPC_GET_ARG1(answer);
+		*handle = (devmap_handle_t) IPC_GET_ARG1(answer);
 	
 	return retval;
 }
 
-devmap_handle_type_t devmap_handle_probe(dev_handle_t handle)
+devmap_handle_type_t devmap_handle_probe(devmap_handle_t handle)
 {
 	int phone = devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING);
@@ -255,5 +255,5 @@
 }
 
-int devmap_device_connect(dev_handle_t handle, unsigned int flags)
+int devmap_device_connect(devmap_handle_t handle, unsigned int flags)
 {
 	int phone;
@@ -305,5 +305,5 @@
 }
 
-static size_t devmap_count_devices_internal(int phone, dev_handle_t ns_handle)
+static size_t devmap_count_devices_internal(int phone, devmap_handle_t ns_handle)
 {
 	ipcarg_t count;
@@ -325,5 +325,5 @@
 }
 
-size_t devmap_count_devices(dev_handle_t ns_handle)
+size_t devmap_count_devices(devmap_handle_t ns_handle)
 {
 	int phone = devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING);
@@ -387,5 +387,5 @@
 }
 
-size_t devmap_get_devices(dev_handle_t ns_handle, dev_desc_t **data)
+size_t devmap_get_devices(devmap_handle_t ns_handle, dev_desc_t **data)
 {
 	int phone = devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING);
Index: uspace/lib/c/generic/net/modules.c
===================================================================
--- uspace/lib/c/generic/net/modules.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/generic/net/modules.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -41,5 +41,5 @@
 #include <async.h>
 #include <malloc.h>
-#include <err.h>
+#include <errno.h>
 #include <sys/time.h>
 
@@ -137,5 +137,5 @@
     ipcarg_t arg3, async_client_conn_t client_receiver, suseconds_t timeout)
 {
-	ERROR_DECLARE;
+	int rc;
 	
 	/* Connect to the needed service */
@@ -144,8 +144,9 @@
 		/* Request the bidirectional connection */
 		ipcarg_t phonehash;
-		if (ERROR_OCCURRED(ipc_connect_to_me(phone, arg1, arg2, arg3,
-		    &phonehash))) {
+		
+		rc = ipc_connect_to_me(phone, arg1, arg2, arg3, &phonehash);
+		if (rc != EOK) {
 			ipc_hangup(phone);
-			return ERROR_CODE;
+			return rc;
 		}
 		async_new_connection(phonehash, 0, NULL, client_receiver);
@@ -212,7 +213,6 @@
 int data_receive(void **data, size_t *length)
 {
-	ERROR_DECLARE;
-
 	ipc_callid_t callid;
+	int rc;
 
 	if (!data || !length)
@@ -229,7 +229,8 @@
 
 	// fetch the data
-	if (ERROR_OCCURRED(async_data_write_finalize(callid, *data, *length))) {
+	rc = async_data_write_finalize(callid, *data, *length);
+	if (rc != EOK) {
 		free(data);
-		return ERROR_CODE;
+		return rc;
 	}
 
Index: uspace/lib/c/generic/net/packet.c
===================================================================
--- uspace/lib/c/generic/net/packet.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/generic/net/packet.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -41,5 +41,4 @@
 #include <unistd.h>
 #include <errno.h>
-#include <err.h>
 
 #include <sys/mman.h>
@@ -91,11 +90,13 @@
 int pm_init(void)
 {
-	ERROR_DECLARE;
+	int rc;
 
 	fibril_rwlock_initialize(&pm_globals.lock);
+	
 	fibril_rwlock_write_lock(&pm_globals.lock);
-	ERROR_PROPAGATE(gpm_initialize(&pm_globals.packet_map));
+	rc = gpm_initialize(&pm_globals.packet_map);
 	fibril_rwlock_write_unlock(&pm_globals.lock);
-	return EOK;
+	
+	return rc;
 }
 
@@ -139,7 +140,6 @@
 int pm_add(packet_t packet)
 {
-	ERROR_DECLARE;
-
 	packet_map_ref map;
+	int rc;
 
 	if (!packet_is_valid(packet))
@@ -160,9 +160,9 @@
 			}
 			bzero(map, sizeof(packet_map_t));
-			if ((ERROR_CODE =
-			    gpm_add(&pm_globals.packet_map, map)) < 0) {
+			rc = gpm_add(&pm_globals.packet_map, map);
+			if (rc < 0) {
 				fibril_rwlock_write_unlock(&pm_globals.lock);
 				free(map);
-				return ERROR_CODE;
+				return rc;
 			}
 		} while (PACKET_MAP_PAGE(packet->packet_id) >=
Index: uspace/lib/c/generic/net/socket_client.c
===================================================================
--- uspace/lib/c/generic/net/socket_client.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/generic/net/socket_client.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -43,5 +43,4 @@
 #include <stdlib.h>
 #include <errno.h>
-#include <err.h>
 
 #include <ipc/services.h>
@@ -212,9 +211,8 @@
 static void socket_connection(ipc_callid_t iid, ipc_call_t * icall)
 {
-	ERROR_DECLARE;
-
 	ipc_callid_t callid;
 	ipc_call_t call;
 	socket_ref socket;
+	int rc;
 
 loop:
@@ -231,5 +229,5 @@
 		    SOCKET_GET_SOCKET_ID(call));
 		if (!socket) {
-			ERROR_CODE = ENOTSOCK;
+			rc = ENOTSOCK;
 			fibril_rwlock_read_unlock(&socket_globals.lock);
 			break;
@@ -240,7 +238,8 @@
 			fibril_mutex_lock(&socket->receive_lock);
 			// push the number of received packet fragments
-			if (!ERROR_OCCURRED(dyn_fifo_push(&socket->received,
+			rc = dyn_fifo_push(&socket->received,
 			    SOCKET_GET_DATA_FRAGMENTS(call),
-			    SOCKET_MAX_RECEIVED_SIZE))) {
+			    SOCKET_MAX_RECEIVED_SIZE);
+			if (rc == EOK) {
 				// signal the received packet
 				fibril_condvar_signal(&socket->receive_signal);
@@ -252,6 +251,7 @@
 			// push the new socket identifier
 			fibril_mutex_lock(&socket->accept_lock);
-			if (!ERROR_OCCURRED(dyn_fifo_push(&socket->accepted,
-			    1, SOCKET_MAX_ACCEPTED_SIZE))) {
+			rc = dyn_fifo_push(&socket->accepted, 1,
+			    SOCKET_MAX_ACCEPTED_SIZE);
+			if (rc == EOK) {
 				// signal the accepted socket
 				fibril_condvar_signal(&socket->accept_signal);
@@ -261,5 +261,5 @@
 
 		default:
-			ERROR_CODE = ENOTSUP;
+			rc = ENOTSUP;
 		}
 
@@ -280,8 +280,8 @@
 
 	default:
-		ERROR_CODE = ENOTSUP;
-	}
-
-	ipc_answer_0(callid, (ipcarg_t) ERROR_CODE);
+		rc = ENOTSUP;
+	}
+
+	ipc_answer_0(callid, (ipcarg_t) rc);
 	goto loop;
 }
@@ -405,6 +405,4 @@
 int socket(int domain, int type, int protocol)
 {
-	ERROR_DECLARE;
-
 	socket_ref socket;
 	int phone;
@@ -413,4 +411,5 @@
 	ipcarg_t fragment_size;
 	ipcarg_t header_size;
+	int rc;
 
 	// find the appropriate service
@@ -479,9 +478,10 @@
 	}
 
-	if (ERROR_OCCURRED((int) async_req_3_3(phone, NET_SOCKET, socket_id, 0,
-	    service, NULL, &fragment_size, &header_size))) {
+	rc = (int) async_req_3_3(phone, NET_SOCKET, socket_id, 0, service, NULL,
+	    &fragment_size, &header_size);
+	if (rc != EOK) {
 		fibril_rwlock_write_unlock(&socket_globals.lock);
 		free(socket);
-		return ERROR_CODE;
+		return rc;
 	}
 
@@ -492,8 +492,8 @@
 	socket_initialize(socket, socket_id, phone, service);
 	// store the new socket
-	ERROR_CODE = sockets_add(socket_get_sockets(), socket_id, socket);
+	rc = sockets_add(socket_get_sockets(), socket_id, socket);
 
 	fibril_rwlock_write_unlock(&socket_globals.lock);
-	if (ERROR_CODE < 0) {
+	if (rc < 0) {
 		dyn_fifo_destroy(&socket->received);
 		dyn_fifo_destroy(&socket->accepted);
@@ -501,5 +501,5 @@
 		async_msg_3(phone, NET_SOCKET_CLOSE, (ipcarg_t) socket_id, 0,
 		    service);
-		return ERROR_CODE;
+		return rc;
 	}
 
@@ -770,7 +770,6 @@
 int closesocket(int socket_id)
 {
-	ERROR_DECLARE;
-
 	socket_ref socket;
+	int rc;
 
 	fibril_rwlock_write_lock(&socket_globals.lock);
@@ -787,6 +786,10 @@
 
 	// request close
-	ERROR_PROPAGATE((int) async_req_3_0(socket->phone, NET_SOCKET_CLOSE,
-	    (ipcarg_t) socket->socket_id, 0, socket->service));
+	rc = (int) async_req_3_0(socket->phone, NET_SOCKET_CLOSE,
+	    (ipcarg_t) socket->socket_id, 0, socket->service);
+	if (rc != EOK) {
+		fibril_rwlock_write_unlock(&socket_globals.lock);
+		return rc;
+	}
 	// free the socket structure
 	socket_destroy(socket);
Index: uspace/lib/c/generic/vfs/vfs.c
===================================================================
--- uspace/lib/c/generic/vfs/vfs.c	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/generic/vfs/vfs.c	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -136,6 +136,6 @@
 	}
 	
-	dev_handle_t dev_handle;
-	int res = devmap_device_get_handle(fqdn, &dev_handle, flags);
+	devmap_handle_t devmap_handle;
+	int res = devmap_device_get_handle(fqdn, &devmap_handle, flags);
 	if (res != EOK) {
 		if (null_id != -1)
@@ -159,5 +159,5 @@
 	
 	ipcarg_t rc_orig;
-	aid_t req = async_send_2(vfs_phone, VFS_IN_MOUNT, dev_handle, flags, NULL);
+	aid_t req = async_send_2(vfs_phone, VFS_IN_MOUNT, devmap_handle, flags, NULL);
 	ipcarg_t rc = async_data_write_start(vfs_phone, (void *) mpa, mpa_size);
 	if (rc != EOK) {
@@ -328,5 +328,5 @@
 	ipc_call_t answer;
 	aid_t req = async_send_4(vfs_phone, VFS_IN_OPEN_NODE, node->fs_handle,
-	    node->dev_handle, node->index, oflag, &answer);
+	    node->devmap_handle, node->index, oflag, &answer);
 	
 	ipcarg_t rc;
@@ -797,5 +797,5 @@
 	if (rc == EOK) {
 		node->fs_handle = stat.fs_handle;
-		node->dev_handle = stat.dev_handle;
+		node->devmap_handle = stat.devmap_handle;
 		node->index = stat.index;
 	}
Index: uspace/lib/c/include/adt/generic_char_map.h
===================================================================
--- uspace/lib/c/include/adt/generic_char_map.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/include/adt/generic_char_map.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -40,5 +40,4 @@
 #include <unistd.h>
 #include <errno.h>
-#include <err.h>
 
 #include <adt/char_map.h>
@@ -85,5 +84,5 @@
 	     type *value) \
 	{ \
-		ERROR_DECLARE; \
+		int rc; \
 		int index; \
 		if (!name##_is_valid(map)) \
@@ -92,8 +91,8 @@
 		if (index < 0) \
 			return index; \
-		if (ERROR_OCCURRED(char_map_add(&map->names, name, length, \
-		    index))) { \
+		rc = char_map_add(&map->names, name, length, index); \
+		if (rc != EOK) { \
 			name##_items_exclude_index(&map->values, index); \
-			return ERROR_CODE; \
+			return rc; \
 		} \
 		return EOK; \
@@ -141,11 +140,14 @@
 	int name##_initialize(name##_ref map) \
 	{ \
-		ERROR_DECLARE; \
+		int rc; \
 		if (!map) \
 			return EINVAL; \
-		ERROR_PROPAGATE(char_map_initialize(&map->names)); \
-		if (ERROR_OCCURRED(name##_items_initialize(&map->values))) { \
+		rc = char_map_initialize(&map->names); \
+		if (rc != EOK) \
+			return rc; \
+		rc = name##_items_initialize(&map->values); \
+		if (rc != EOK) { \
 			char_map_destroy(&map->names); \
-			return ERROR_CODE; \
+			return rc; \
 		} \
 		map->magic = GENERIC_CHAR_MAP_MAGIC_VALUE; \
Index: uspace/lib/c/include/devman.h
===================================================================
--- uspace/lib/c/include/devman.h	(revision 69e0d6d76d229cc73c6c8a11802d5f2e93167ca4)
+++ uspace/lib/c/include/devman.h	(revision cb569e62113a2d98fcd62f99a984ae74d5329acf)
@@ -42,16 +42,18 @@
 
 
-int devman_get_phone(devman_interface_t, unsigned int);
-void devman_hangup_phone(devman_interface_t iface);
+extern int devman_get_phone(devman_interface_t, unsigned int);
+extern void devman_hangup_phone(devman_interface_t);
 
-int devman_driver_register(const char *, async_client_conn_t);
-int devman_child_device_register(const char *, match_id_list_t *, device_handle_t, device_handle_t *);
+extern int devman_driver_register(const char *, async_client_conn_t);
+extern int devman_child_device_register(const char *, match_id_list_t *,
+    devman_handle_t, devman_handle_t *);
 
-int devman_device_connect(device_handle_t handle, unsigned int flags);
-int devman_parent_device_connect(device_handle_t handle, unsigned int flags);
+extern int devman_device_connect(devman_handle_t, unsigned int);
+extern int devman_parent_device_connect(devman_handle_t, unsigned int);
 
-int devman_device_get_handle(const char *pathname, device_handle_t *handle, unsigned int flags);
+extern int devman_device_get_handle(const char *, devman_handle_t *,
+    unsigned int);
 
-int devman_add_device_to_class(device_handle_t dev_handle, const char *class_name);
+extern int devman_add_device_to_class(devman_handle_t, const char *);
 
 #endif
